rm(list=ls())
setwd(".../2P_EM_2018")
library(foreign)
library(sampling)
library(survey)
library(writexl)
library(dplyr)

medida_L=as.data.frame(matrix(data=NA,nrow=10,ncol=3, byrow=TRUE))
n1_L=as.data.frame(matrix(data=NA,nrow=10,ncol=3, byrow=TRUE))
n2_L=as.data.frame(matrix(data=NA,nrow=10,ncol=3, byrow=TRUE))
n3_L=as.data.frame(matrix(data=NA,nrow=10,ncol=3, byrow=TRUE))

medida_M=as.data.frame(matrix(data=NA,nrow=10,ncol=3, byrow=TRUE))
n1_M=as.data.frame(matrix(data=NA,nrow=10,ncol=3, byrow=TRUE))
n2_M=as.data.frame(matrix(data=NA,nrow=10,ncol=3, byrow=TRUE))
n3_M=as.data.frame(matrix(data=NA,nrow=10,ncol=3, byrow=TRUE))

######################################
#Clculo de resultados               #
######################################

###lectura###

alumnos=read.spss("2P_EM_2018_WEB.sav", use.value.labels=FALSE,to.data.frame=TRUE)

alumnos_L <- alumnos %>% filter(!is.na(grupo_L)==1)

alumnos_L$grupo_L = as.factor(alumnos_L$grupo_L)

options(survey.lonely.psu = "certainty")

diseppt_L=svydesign(id=~ID_IE+ID_seccion+cor_est,strata=~ESTRATO,nest=TRUE,fpc=~pikIE+Prob_seccion+Prob_NR_lectura ,data=alumnos_L,pps = "brewer")
summary(diseppt_L)

rF1_L = data.frame(svymean(~M500_L+grupo_L,deff=T,design=diseppt_L,na.rm=T))


#---------------------Estimacin  por gestin-------------------------------------#
estimacionG_L<-function(G){
  samplec1<-subset(alumnos_L, Gestion2==G)
  samplec1
  
  dclus<-svydesign(id=~ID_IE+ID_seccion+cor_est,strata=~ESTRATO,fpc=~pikIE+Prob_seccion+Prob_NR_lectura ,nest=TRUE,data=samplec1,pps = "brewer")
  
  b<-data.frame(svymean(~M500_L+grupo_L,deff=T,design=dclus,na.rm=T))
  b
}
estimacionG_L (1)
estimacionG_L (2)

#---------------------Estimacin  por rea-------------------------------------#
estimacionA_L<-function(A){
  samplec1<-subset(alumnos_L, Area==A)
  samplec1
  
  dclus<-svydesign(id=~ID_IE+ID_seccion+cor_est,strata=~ESTRATO,fpc=~pikIE+Prob_seccion+Prob_NR_lectura ,nest=TRUE,data=samplec1,pps = "brewer")
  
  b<-data.frame(svymean(~M500_L+grupo_L,deff=T,design=dclus,na.rm=T))
  b
}
estimacionA_L (1)
estimacionA_L (2)

#---------------------Estimacin  por caracterstica-------------------------------------#
estimacionC_L<-function(C){
  samplec1<-subset(alumnos_L, Caracteristica2==C)
  samplec1
  
  dclus<-svydesign(id=~ID_IE+ID_seccion+cor_est,strata=~ESTRATO,fpc=~pikIE+Prob_seccion+Prob_NR_lectura ,nest=TRUE,data=samplec1,pps = "brewer")
  
  b<-data.frame(svymean(~M500_L+grupo_L,deff=T,design=dclus,na.rm=T))
  b
}
estimacionC_L (1)
estimacionC_L (2)

#---------------------Estimacin  por sexo-------------------------------------#
estimacionS_L<-function(S){
  samplec1<-subset(alumnos_L, sexo==S)
  samplec1
  
  dclus<-svydesign(id=~ID_IE+ID_seccion+cor_est,strata=~ESTRATO,fpc=~pikIE+Prob_seccion+Prob_NR_lectura ,nest=TRUE,data=samplec1,pps = "brewer")
  
  b<-data.frame(svymean(~M500_L+grupo_L,deff=T,design=dclus,na.rm=T))
  b
}
estimacionS_L (0)
estimacionS_L (1)

#---------------------Estimacin  por estatal urbano-------------------------------------#
estimacionE_L<-function(G,A){
  samplec1<-subset(alumnos_L, Gestion2==G & Area==A)
  samplec1
  
  dclus<-svydesign(id=~ID_IE +ID_seccion+cor_est,strata=~ESTRATO,fpc=~pikIE+Prob_seccion+Prob_NR_lectura ,nest=TRUE,data=samplec1,pps = "brewer")
  
  b<-data.frame(svymean(~M500_L+grupo_L,deff=T,design=dclus,na.rm=T))
  b
}
estimacionE_L (1,1)

###############################################################################################

medida_L[1,]=rF1_L[1,]
n1_L[1,]=rF1_L[2,]
n2_L[1,]=rF1_L[3,]
n3_L[1,]=rF1_L[4,]

medida_L[2,]=estimacionG_L(1)[1,]
n1_L[2,]=estimacionG_L(1)[2,]
n2_L[2,]=estimacionG_L(1)[3,]
n3_L[2,]=estimacionG_L(1)[4,]

medida_L[3,]=estimacionG_L(2)[1,]
n1_L[3,]=estimacionG_L(2)[2,]
n2_L[3,]=estimacionG_L(2)[3,]
n3_L[3,]=estimacionG_L(2)[4,]

medida_L[4,]=estimacionA_L(1)[1,]
n1_L[4,]=estimacionA_L(1)[2,]
n2_L[4,]=estimacionA_L(1)[3,]
n3_L[4,]=estimacionA_L(1)[4,]

medida_L[5,]=estimacionA_L(2)[1,]
n1_L[5,]=estimacionA_L(2)[2,]
n2_L[5,]=estimacionA_L(2)[3,]
n3_L[5,]=estimacionA_L(2)[4,]

medida_L[6,]=estimacionC_L(1)[1,]
n1_L[6,]=estimacionC_L(1)[2,]
n2_L[6,]=estimacionC_L(1)[3,]
n3_L[6,]=estimacionC_L(1)[4,]

medida_L[7,]=estimacionC_L(2)[1,]
n1_L[7,]=estimacionC_L(2)[2,]
n2_L[7,]=estimacionC_L(2)[3,]
n3_L[7,]=estimacionC_L(2)[4,]

medida_L[8,]=estimacionS_L(0)[1,]
n1_L[8,]=estimacionS_L(0)[2,]
n2_L[8,]=estimacionS_L(0)[3,]
n3_L[8,]=estimacionS_L(0)[4,]

medida_L[9,]=estimacionS_L(1)[1,]
n1_L[9,]=estimacionS_L(1)[2,]
n2_L[9,]=estimacionS_L(1)[3,]
n3_L[9,]=estimacionS_L(1)[4,]

medida_L[10,]=estimacionE_L(1,1)[1,]
n1_L[10,]=estimacionE_L(1,1)[2,]
n2_L[10,]=estimacionE_L(1,1)[3,]
n3_L[10,]=estimacionE_L(1,1)[4,]

###matemtica###

alumnos_M <- alumnos %>% filter(!is.na(grupo_M)==1)

alumnos_M$grupo_M = as.factor(alumnos_M$grupo_M)

diseppt_M=svydesign(id=~ID_IE+ID_seccion+cor_est,strata=~ESTRATO,nest=TRUE,fpc=~pikIE+Prob_seccion+Prob_NR_mate,data=alumnos_M,pps = "brewer")
summary(diseppt_M)

rF1_M = data.frame(svymean(~M500_M+grupo_M,deff=T,design=diseppt_M,na.rm=T))


#---------------------Estimacin  por gestin-------------------------------------#
estimacionG_M<-function(G){
  samplec1<-subset(alumnos_M, Gestion2==G)
  samplec1
  
  dclus<-svydesign(id=~ID_IE+ID_seccion+cor_est,strata=~ESTRATO,fpc=~pikIE+Prob_seccion+Prob_NR_mate ,nest=TRUE,data=samplec1,pps = "brewer")
  
  b<-data.frame(svymean(~M500_M+grupo_M,deff=T,design=dclus,na.rm=T))
  b
}
estimacionG_M (1)
estimacionG_M (2)

#---------------------Estimacin  por rea-------------------------------------#
estimacionA_M<-function(A){
  samplec1<-subset(alumnos_M, Area==A)
  samplec1
  
  dclus<-svydesign(id=~ID_IE+ID_seccion+cor_est,strata=~ESTRATO,fpc=~pikIE+Prob_seccion+Prob_NR_mate ,nest=TRUE,data=samplec1,pps = "brewer")
  
  b<-data.frame(svymean(~M500_M+grupo_M,deff=T,design=dclus,na.rm=T))
  b
}
estimacionA_M (1)
estimacionA_M (2)

#---------------------Estimacin  por caracterstica-------------------------------------#
estimacionC_M<-function(C){
  samplec1<-subset(alumnos_M, Caracteristica2==C)
  samplec1
  
  dclus<-svydesign(id=~ID_IE+ID_seccion+cor_est,strata=~ESTRATO,fpc=~pikIE+Prob_seccion+Prob_NR_mate ,nest=TRUE,data=samplec1,pps = "brewer")
  
  b<-data.frame(svymean(~M500_M+grupo_M,deff=T,design=dclus,na.rm=T))
  b
}
estimacionC_M (1)
estimacionC_M (2)

#---------------------Estimacin  por sexo-------------------------------------#
estimacionS_M<-function(S){
  samplec1<-subset(alumnos_M, sexo==S)
  samplec1
  
  dclus<-svydesign(id=~ID_IE+ID_seccion+cor_est,strata=~ESTRATO,fpc=~pikIE+Prob_seccion+Prob_NR_mate ,nest=TRUE,data=samplec1,pps = "brewer")
  
  b<-data.frame(svymean(~M500_M+grupo_M,deff=T,design=dclus,na.rm=T))
  b
}
estimacionS_M (0)
estimacionS_M (1)

#---------------------Estimacin  por estatal urbano-------------------------------------#
estimacionE_M<-function(G,A){
  samplec1<-subset(alumnos_M, Gestion2==G & Area==A)
  samplec1
  
  dclus<-svydesign(id=~ID_IE +ID_seccion+cor_est,strata=~ESTRATO,fpc=~pikIE+Prob_seccion+Prob_NR_mate ,nest=TRUE,data=samplec1,pps = "brewer")
  
  b<-data.frame(svymean(~M500_M+grupo_M,deff=T,design=dclus,na.rm=T))
  b
}
estimacionE_M (1,1)

###############################################################################################

medida_M[1,]=rF1_M[1,]
n1_M[1,]=rF1_M[2,]
n2_M[1,]=rF1_M[3,]
n3_M[1,]=rF1_M[4,]

medida_M[2,]=estimacionG_M(1)[1,]
n1_M[2,]=estimacionG_M(1)[2,]
n2_M[2,]=estimacionG_M(1)[3,]
n3_M[2,]=estimacionG_M(1)[4,]

medida_M[3,]=estimacionG_M(2)[1,]
n1_M[3,]=estimacionG_M(2)[2,]
n2_M[3,]=estimacionG_M(2)[3,]
n3_M[3,]=estimacionG_M(2)[4,]

medida_M[4,]=estimacionA_M(1)[1,]
n1_M[4,]=estimacionA_M(1)[2,]
n2_M[4,]=estimacionA_M(1)[3,]
n3_M[4,]=estimacionA_M(1)[4,]

medida_M[5,]=estimacionA_M(2)[1,]
n1_M[5,]=estimacionA_M(2)[2,]
n2_M[5,]=estimacionA_M(2)[3,]
n3_M[5,]=estimacionA_M(2)[4,]

medida_M[6,]=estimacionC_M(1)[1,]
n1_M[6,]=estimacionC_M(1)[2,]
n2_M[6,]=estimacionC_M(1)[3,]
n3_M[6,]=estimacionC_M(1)[4,]

medida_M[7,]=estimacionC_M(2)[1,]
n1_M[7,]=estimacionC_M(2)[2,]
n2_M[7,]=estimacionC_M(2)[3,]
n3_M[7,]=estimacionC_M(2)[4,]

medida_M[8,]=estimacionS_M(0)[1,]
n1_M[8,]=estimacionS_M(0)[2,]
n2_M[8,]=estimacionS_M(0)[3,]
n3_M[8,]=estimacionS_M(0)[4,]

medida_M[9,]=estimacionS_M(1)[1,]
n1_M[9,]=estimacionS_M(1)[2,]
n2_M[9,]=estimacionS_M(1)[3,]
n3_M[9,]=estimacionS_M(1)[4,]

medida_M[10,]=estimacionE_M(1,1)[1,]
n1_M[10,]=estimacionE_M(1,1)[2,]
n2_M[10,]=estimacionE_M(1,1)[3,]
n3_M[10,]=estimacionE_M(1,1)[4,]

Tabla_L=cbind.data.frame(round(n1_L[,1]*100,1),round(n1_L[,2]*100,2),round(n2_L[,1]*100,1),round(n2_L[,2]*100,2),
                         round(n3_L[,1]*100,1),round(n3_L[,2]*100,2),round(medida_L[,1],0),round(medida_L[,2],2))

row.names(Tabla_L)=c("Nacional","Estatal","No_estatal","Urbana","Rural","Polidocente_Completo","Unidocente/Multigrado",
                     "Hombre","Mujer","Estatal_Urbano")

colnames(Tabla_L)=c("En_inicio","ee_En_inicio","En_proceso","ee_En_proceso","Satisfactorio","ee_Satisfactorio",
                    "Medida_Lectura","ee_Medida_Lectura")

Tabla_M=cbind.data.frame(round(n1_M[,1]*100,1),round(n1_M[,2]*100,2),round(n2_M[,1]*100,1),round(n2_M[,2]*100,2),
                         round(n3_M[,1]*100,1),round(n3_M[,2]*100,2),round(medida_M[,1],0),round(medida_M[,2],2))

row.names(Tabla_M)=c("Nacional","Estatal","No_estatal","Urbana","Rural","Polidocente_Completo","Unidocente/Multigrado",
                     "Hombre","Mujer","Estatal_Urbano")

colnames(Tabla_M)=c("En_inicio","ee_En_inicio","En_proceso","ee_En_proceso","Satisfactorio","ee_Satisfactorio",
                    "Medida_Matemtica","ee_Medida_Matemtica")

Tabla_L$variables=row.names(Tabla_L)
Tabla_L=Tabla_L[,c(9,1:8)]
Tabla_M$variables=row.names(Tabla_M)
Tabla_M=Tabla_M[,c(9,1:8)]

write_xlsx(Tabla_L,'Lectura 2P_2018.xlsx')
write_xlsx(Tabla_M,'Matemtica 2P_2018.xlsx')
